% Adaptive notch filter
% 3 sinusoid input signal
% 3 L=2 filters dedicated to each frequency

Ts = 0.0001;
N  = 200;

f_notch1 = 50;  w_notch1 = 2*pi*f_notch1;
f_notch2 = 100; w_notch2 = 2*pi*f_notch2;
f_notch3 = 150; w_notch3 = 2*pi*f_notch3;

L1  = 2;
mu1 = 0.1; 
L2  = 2;
mu2 = 0.1; 
L3  = 2;
mu3 = 0.1; 

W1 = zeros(L1,1);
X1 = zeros(L1,1);
W2 = zeros(L2,1);
X2 = zeros(L2,1);
W3 = zeros(L3,1);
X3 = zeros(L3,1);
J  = 0;

Dv = zeros(N,1);
Ev = zeros(N,1);
Jv = NaN;
%Wv = zeros(N,L);

figure(1)
subplot(211)
hp1a = plot(0:Ts:(N-1)*Ts,Dv,'b');
hold on
hp1b = plot(0:Ts:(N-1)*Ts,Ev,'g');
hold off
set(hp1a,'EraseMode','xor');
set(hp1b,'EraseMode','xor');

t  = 0;
ni = 0;
while 1
   ni   = ni + 1;
   t    = t + Ts;
   x1 = sin(w_notch1*t);
   x2 = sin(w_notch2*t);
   x3 = + sin(w_notch3*t);
   d = 2*sin(w_notch1*t+pi/6) + 5*sin(w_notch2*t-pi/4) + 3*sin(w_notch3*t+2*pi/3); 
   X1 = [x1; X1(1:end-1)];
   X2 = [x2; X2(1:end-1)];
   X3 = [x3; X3(1:end-1)];
   y1 = W1'*X1;
   y2 = W2'*X2;
   y3 = W3'*X3;
   e = d - (y1+y2+y3);
   W1 = W1 + mu1*X1*e;
   W2 = W2 + mu2*X2*e;
   W3 = W3 + mu3*X3*e;
   J  = (J*(ni-1)+e'*e)/ni;

   Dv = [Dv(2:end);d];
   Ev = [Ev(2:end); e];
%   Wv = [Wv(2:end,:); W'];
   if rem(ni,N)==0
      Jv = [Jv; J];
      subplot(211),title(['Current time = ' num2str(t)])
      set(hp1a,'XData',t-(N-1)*Ts:Ts:t);
      set(hp1a,'YData',Dv);
      set(hp1b,'XData',t-(N-1)*Ts:Ts:t);
      set(hp1b,'YData',Ev);
      axis([t-(N-1)*Ts t -10 10])
      drawnow
      subplot(212)
      plot([0:length(Jv)-1]*N*Ts,Jv)
      axis([0 t 0 max(Jv)])
      xlabel('CTRL-C to terminate')
   end
end



