% Adaptive notch filter
% 3 sinusoid input signal
% Single long filter

Ts = 0.0001;
N  = 200;

f_notch1 = 50;  w_notch1 = 2*pi*f_notch1;
f_notch2 = 100; w_notch2 = 2*pi*f_notch2;
f_notch3 = 150*0.9; w_notch3 = 2*pi*f_notch3;

L  = (1/50)/Ts;
mu = 0.1; 


W  = zeros(L,1);
J  = 0;

Dv = zeros(N,1);
Ev = zeros(N,1);
Jv = NaN;
%Wv = zeros(N,L);

figure(1)
subplot(211)
hp1a = plot(0:Ts:(N-1)*Ts,Dv,'b');
hold on
hp1b = plot(0:Ts:(N-1)*Ts,Ev,'g');
hold off
set(hp1a,'EraseMode','xor');
set(hp1b,'EraseMode','xor');

t  = 0;
ni = 0;
while 1
   ni = ni + 1;
   t  = t + Ts;
   %x  = sin(w_notch1*t) + sin(w_notch2*t) + sin(w_notch3*t); 
   d  = 2*sin(w_notch1*t+pi/6) + 5*sin(w_notch2*t-pi/4) + 3*sin(w_notch3*t+2*pi/3); 
   y  = W(rem(ni-1,L)+1);
   e  = d - y;
   W(rem(ni-1,L)+1)  = W(rem(ni-1,L)+1) + mu*e;
   J  = (J*(ni-1)+e'*e)/ni;

   Dv = [Dv(2:end);d];
   Ev = [Ev(2:end); e];
%   Wv = [Wv(2:end,:); W'];
   if rem(ni,N)==0
      Jv = [Jv; J];
      subplot(211),title(['Current time = ' num2str(t)])
      set(hp1a,'XData',t-(N-1)*Ts:Ts:t);
      set(hp1a,'YData',Dv);
      set(hp1b,'XData',t-(N-1)*Ts:Ts:t);
      set(hp1b,'YData',Ev);
      axis([t-(N-1)*Ts t -10 10])
      drawnow
      subplot(212)
      plot([0:length(Jv)-1]*N*Ts,Jv)
      axis([0 t 0 max(Jv)])
      xlabel('CTRL-C to terminate')
   end
end



