N = 6;

Ni = 1000;
mu = 0.1; 
t = 1:Ni;
x1 = sin(2*pi*t/N);
x2 = cos(2*pi*t/N);
d = 2*cos(2*pi*t/N+36*pi/180);
y = zeros(Ni,1);
w = zeros(2,Ni);
w(:,1) = randn(2,1);
J = zeros(Ni,1);
J(1) = d*d'/Ni;

for pe=-120:10:120 %phase error
   x1p = sin(2*pi*t/N -pe*pi/180);
   x2p = cos(2*pi*t/N -pe*pi/180);
   for n=2:Ni
      y(n) = w(1,n-1)*x1(n) + w(2,n-1)*x2(n);
      e(n) = d(n)-y(n);
      w(1,n) = w(1,n-1) + mu*x1p(n)*e(n);
      w(2,n) = w(2,n-1) + mu*x2p(n)*e(n);
      J(n) = e(n)*e(n)'/Ni;
   end
   subplot(211)
   plot(t,d,t,y)
   title(['Phase error in the secondary path estimate = ' num2str(pe) ''])
   axis([1 Ni -5 5])
   subplot(212),plot(t,J,'k')
   pause
end

