N = 16;
noisevar = 0.01;
w0 = -2:0.1:8;
w1 = -10:0.1:0;
for i0=1:length(w0)
   for i1=1:length(w1)
      MSE(i0,i1) = (0.5+noisevar)*(w0(i0)^2+w1(i1)^2) + w0(i0)*w1(i1)*cos(2*pi/N) + 2*w1(i1)*sin(2*pi/N) + 2;
   end
end

R = 0.5*[1+2*noisevar cos(2*pi/N); cos(2*pi/N) 1+2*noisevar];
p = [0; -sin(2*pi/N)];
wopt = R\p;

figure(1)
[V,D]=eig(R);
contour(w0,w1,MSE',[0:1:10])
hold on
plot(wopt(1),wopt(2),'k+')
plot([-2 8],([-2 8]-wopt(1))*V(2,1)/V(1,1)+wopt(2),'k--')
plot([-2 8],([-2 8]-wopt(1))*V(2,2)/V(1,2)+wopt(2),'k--')

Ni = 250;
mu = 0.1; 
n = 1:Ni;
x = sin(2*pi*n/N)+randn(1,Ni)*sqrt(noisevar);
d = 2*cos(2*pi*n/N);
y = zeros(Ni,1);
w = zeros(2,Ni);
w(:,1) = [0 0]';
for n=2:Ni
   y(n) = w(1,n-1)*x(n) + w(2,n-1)*x(n-1);
   e(n) = d(n)-y(n);
   w(1,n) = w(1,n-1) + mu*x(n)*e(n);
   w(2,n) = w(2,n-1) + mu*x(n-1)*e(n);
end
plot(w(1,:),w(2,:),'k')
hold off

figure(2)
plot(1:Ni,e)

pause
figure(1)
hold on
Ni = 500;
mu = 0.05; 
n = 1:Ni;
x = sin(2*pi*n/N)+randn(1,Ni)*sqrt(noisevar);
d = 2*cos(2*pi*n/N);
y = zeros(Ni,1);
w = zeros(2,Ni);
w(:,1) = [4 -10]';
for n=2:Ni
   y(n) = w(1,n-1)*x(n) + w(2,n-1)*x(n-1);
   e(n) = d(n)-y(n);
   w(1,n) = w(1,n-1) + mu*x(n)*e(n);
   w(2,n) = w(2,n-1) + mu*x(n-1)*e(n);
end
plot(w(1,:),w(2,:),'k')
hold off
