N = 6;
w0 = -3:0.1:4;
w1 = -4:0.1:0;
for i0=1:length(w0)
   for i1=1:length(w1)
      MSE(i0,i1) = 0.5*(w0(i0)^2+w1(i1)^2) + w0(i0)*w1(i1)*cos(2*pi/N) + 2*w1(i1)*sin(2*pi/N) + 2;
   end
end

R = 0.5*[1 cos(2*pi/N); cos(2*pi/N) 1];
p = [0; -sin(2*pi/N)];
wopt = R\p;

figure(1)
mesh(w0,w1,MSE')
xlabel('w_0')
ylabel('w_1')
hold on
contour(w0,w1,MSE',1:10)
axis([-3 4 -4 0 0 12])
hold off

figure(2)
[c,h] = contour(w0,w1,MSE',[0:0.5:5]);
clabel(c,h)
xlabel('w_0')
ylabel('w_1')
hold on 
plot(wopt(1),wopt(2),'k+')
hold off

figure(3)
[V,D]=eig(R);
contour(w0,w1,MSE',[0:0.5:5])
hold on
plot(wopt(1),wopt(2),'k+')
plot([-3 4],([-3 4]-wopt(1))*V(2,1)/V(1,1)+wopt(2),'k--')
plot([-3 4],([-3 4]-wopt(1))*V(2,2)/V(1,2)+wopt(2),'k--')
hold off


figure(4)
[V,D]=eig(R);
contour(w0,w1,MSE',[0:0.5:5])
hold on
plot(wopt(1),wopt(2),'k+')
plot([-3 4],([-3 4]-wopt(1))*V(2,1)/V(1,1)+wopt(2),'k--')
plot([-3 4],([-3 4]-wopt(1))*V(2,2)/V(1,2)+wopt(2),'k--')

Ni = 1000;
mu = 0.1; 
n = 1:Ni;
x = sin(2*pi*n/N);
d = 2*cos(2*pi*n/N);
y = zeros(Ni,1);
for w0in = -3:4
   for w1in = -4:0
      w = zeros(2,Ni);
      w(:,1) = [w0in w1in]';
      for n=2:Ni
         y(n) = w(1,n-1)*x(n) + w(2,n-1)*x(n-1);
         e(n) = d(n)-y(n);
         w(1,n) = w(1,n-1) + mu*x(n)*e(n);
         w(2,n) = w(2,n-1) + mu*x(n-1)*e(n);
      end
      plot(w(1,:),w(2,:),'k')
   end
end
hold off
axis([-3 4 -4 0])
title(['mu = ' num2str(mu)])

figure(5)
hold on
Ni = 100;
n = 1:Ni;
x = sin(2*pi*n/N);
d = 2*cos(2*pi*n/N);
y = zeros(Ni,1);
J = zeros(Ni,1);
J(1) = d*d'/Ni;
for mu=0.1:0.1:1
   w = zeros(2,Ni);
   w(:,1) = [-3 -4]';
   for n=2:Ni
      y(n) = w(1,n-1)*x(n) + w(2,n-1)*x(n-1);
      e(n) = d(n)-y(n);
      w(1,n) = w(1,n-1) + mu*x(n)*e(n);
      w(2,n) = w(2,n-1) + mu*x(n-1)*e(n);
      J(n) = e(n)*e(n)'/Ni;
   end
   plot(1:Ni,J,'k')
end
hold off

